<?php defined('SYSPATH') OR die('No direct access allowed.');
/**
 * op5sla controller
 * Requires authentication
 *
 *  op5, and the op5 logo are trademarks, servicemarks, registered servicemarks
 *  or registered trademarks of op5 AB.
 *  All other trademarks, servicemarks, registered trademarks, and registered
 *  servicemarks mentioned herein may be the property of their respective owner(s).
 *  The information contained herein is provided AS IS with NO WARRANTY OF ANY
 *  KIND, INCLUDING THE WARRANTY OF DESIGN, MERCHANTABILITY, AND FITNESS FOR A
 *  PARTICULAR PURPOSE.
 */
class Op5sla_Controller extends Sla_Controller
{
	/**
	*	Setup report
	*/
	public function index($input=false)
	{
		$this->setup_options_obj($input, 'op5reports');
		$this->xtra_js[] = 'modules/op5reports/views/reports/js/op5reports';
		return parent::index($input);
	}

	/**
	*	Generate report
	*/
	public function generate($input=false)
	{
		$this->setup_options_obj($input, 'op5reports');
		$this->xtra_js[] = 'modules/op5reports/views/reports/js/op5reports';

		if ($this->options['use_summary'] && $this->options['output_format'] !== 'csv') {
			$summary = new Summary_Controller();
			$summary->options = $this->options;
			$summary->auto_render = false;

			$summary->generate();
			$this->template->set_global('summary', $summary->template->content->content);
		}

		parent::generate($input);
	}

	public static function _helptexts($id)
	{
		# Tag unfinished helptexts with @@@HELPTEXT:<key> to make it
		# easier to find those later
		$helptexts = array(
			'use_pnp' => _("Check this to include performance graphs (if available) in the report."),
			'use_summary' => _("Check this to include a Summary Report.<br>Warning: This can make your reports slow!"),
		);

		if (array_key_exists($id, $helptexts)) {
			echo $helptexts[$id];
		} else
			return parent::_helptexts($id);
	}

	public function add_view($view=false)
	{
		$res = parent::add_view($view);
		if (Kohana::find_file('views', $view . 'op5')) {
			$res->extra_content = parent::add_view($view.'op5');
		}
		return $res;
	}

	protected function setup_options_obj($input = false, $type = false)
	{
		if ($this->options) // If a child class has already set this, leave it alone
		{
			return;
		}
		Op5reports_options::$type = $this->type;
		parent::setup_options_obj($input, 'op5reports');
	}
}
